package ru.dbotthepony.mc.otm.storage;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.world.item.ItemStack;

import javax.annotation.ParametersAreNonnullByDefault;
import java.math.BigDecimal;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public record ItemStackObject(ItemStack stack) implements IStorageObject {
	public static final ItemStackObject EMPTY = new ItemStackObject(ItemStack.EMPTY);

	@Override
	public IStorageObject copy() {
		return new ItemStackObject(stack.copy());
	}

	@Override
	public void setCount(BigDecimal value) {
		stack.setCount(Math.max(value.intValue(), 0));
	}

	public void setCount(int value) {
		stack.setCount(Math.max(value, 0));
	}

	@Override
	public BigDecimal getCount() {
		return new BigDecimal(stack.getCount());
	}

	public int getCountInt() {
		return stack.getCount();
	}

	@Override
	public boolean isEmpty() {
		return stack.isEmpty();
	}
}
